libreorganize/apps/accounts/urls.py
from django.conf import settings
from django.urls import path

from apps.accounts import views

app_name = "apps.accounts"

urlpatterns = [
    # Require VIEW permissions
    path("", views.ListView.as_view(), name="list"),
    path("<int:pk>/", views.DetailView.as_view(), name="detail"),
    path("groups/", views.GroupListView.as_view(), name="groups_list"),
    path("groups/<int:pk>/", views.GroupDetailView.as_view(), name="groups_detail"),
    # Require MANAGE permissions
    path("create/", views.CreateView.as_view(), name="create"),
    path("<int:pk>/edit/", views.EditView.as_view(), name="edit"),
    path("<int:pk>/delete/", views.DeleteView.as_view(), name="delete"),
    path("<int:pk>/password/change/", views.PasswordChangeView.as_view(), name="password_change"),
    path("<int:pk>/permissions/change/", views.PermissionsChangeView.as_view(), name="permissions_change"),
    path("<int:pk>/activate/", views.ActivateView.as_view(), name="activate"),
    path("activate/<uidb64>/<token>/", views.ActivateConfirmView.as_view(), name="activate"),
    path("groups/create/", views.GroupCreateView.as_view(), name="groups_create"),
    path("groups/<int:pk>/edit/", views.GroupEditView.as_view(), name="groups_edit"),
    path("groups/<int:pk>/delete/", views.GroupDeleteView.as_view(), name="groups_delete"),
    # Require NO permissions
    path("login/", views.LoginView.as_view(), name="login"),
    path("logout/", views.LogoutView.as_view(), name="logout"),
    path("password/reset/", views.PasswordResetView.as_view(), name="password_reset"),
    path("password/reset/<uidb64>/<token>/", views.PasswordResetConfirmView.as_view(), name="password_reset"),
]

if settings.CAN_REGISTER:
    urlpatterns += [path("register/", views.RegisterView.as_view(), name="register")]

libreorganize/core/urls.py
import os

from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.views.generic import TemplateView

urlpatterns = []

if os.path.exists(os.path.join(settings.BASE_DIR, "theme")):
    from theme.urls import *

urlpatterns += [
    path("", TemplateView.as_view(template_name="home.html"), name="home"),
    path("accounts/", include("apps.accounts.urls", namespace="accounts")),
    path("boxes/", include("apps.boxes.urls", namespace="boxes")),
    path("events/", include("apps.events.urls", namespace="events")),
    path("news/", include("apps.news.urls", namespace="news")),
    path("votations/", include("apps.votations.urls", namespace="votations")),
    path("wikis/", include("apps.wikis.urls", namespace="wikis")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ckeditor/", include("ckeditor_uploader.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

libreorganize/apps/accounts/models.py
from django.db import models
from django.conf import settings
from django.utils.translation import gettext_lazy as _
from django.contrib.auth.base_user import AbstractBaseUser
from django.contrib.auth.models import Group, PermissionsMixin
from django_countries.fields import CountryField
from django.core.mail import send_mail
from smtplib import SMTPException


from apps.accounts.managers import AccountManager


class Account(AbstractBaseUser, PermissionsMixin):
    # Contains passoword and last_login (from AbstractBaseUser)
    # Contains is_superuser, user_permissions, and groups (from PermissionsMixin)
    email = models.EmailField(unique=True, error_messages={"unique": _("The email is already in use.")})
    first_name = models.CharField(max_length=32)
    last_name = models.CharField(max_length=32)

    title = models.CharField(max_length=8, blank=True)
    date_of_birth = models.DateField(blank=True, null=True)
    gender = models.CharField(max_length=8, blank=True)
    phone_number = models.CharField(max_length=16, blank=True)
    company = models.CharField(max_length=64, blank=True)
    address_line1 = models.CharField(max_length=96, blank=True, help_text=_("Street address, P.O. box"))
    address_line2 = models.CharField(max_length=64, blank=True, help_text=_("Apartment, suite, unit, building, floor"))
    city = models.CharField(max_length=32, blank=True)
    state = models.CharField(max_length=32, blank=True)
    zipcode = models.CharField(max_length=16, blank=True)
    country = CountryField(blank_label="", blank=True)

    avatar = models.ImageField(upload_to="avatars", blank=True, help_text=_("Use a 1:1 image for the best quality"))

    is_active = models.BooleanField(default=True)
    is_superuser = models.BooleanField(default=False, help_text=_("Grants all permissions"))
    groups = models.ManyToManyField(Group, related_name="members", blank=True)
    created_on = models.DateTimeField(auto_now_add=True)
    updated_on = models.DateTimeField(auto_now=True)

    objects = AccountManager()

    USERNAME_FIELD = "email"
    REQUIRED_FIELDS = []

    class Meta:
        ordering = ("last_name", "first_name")
        default_permissions = ()
        permissions = (
            ("view_accounts", "View accounts"),
            ("manage_accounts", "Manage accounts"),
        )

    @property
    def full_name(self):
        return self.first_name + " " + self.last_name

    @property
    def avatar_url(self):
        if self.avatar:
            return self.avatar.url
        return settings.STATIC_URL + "img/avatar.png"

    def __str__(self):
        return self.full_name

    def send_email(self, subject, message, html_message):
        try:
            send_mail(
                subject=subject,
                message=message,
                html_message=html_message,
                from_email=settings.EMAIL_HOST_USER,
                recipient_list=(self.email,),
            )
            return True
        except (ConnectionError, SMTPException):
            return False


class Group(Group):
    created_on = models.DateTimeField(auto_now_add=True)
    updated_on = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.name

    class Meta:
        ordering = ("name",)
        default_permissions = ()
        permissions = (
            ("view_groups", "View groups"),
            ("manage_groups", "Manage groups"),
        )

libreorganize/apps/accounts/views.py
from django.views import View
from django.conf import settings
from django.contrib import messages
from django.contrib.auth import logout
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse
from django.utils.encoding import force_bytes, force_str
from django.utils.http import urlsafe_base64_encode, urlsafe_base64_decode
from django.contrib.auth.tokens import default_token_generator
from django.utils.html import strip_tags
from django.template.loader import render_to_string
from django.utils.translation import gettext_lazy as _

from core.mixins import ModelMixin, PermissionMixin, RedirectMixin
from core.views import CoreListView, CoreDetailView, CoreCreateView, CoreEditView, CoreDeleteView

from apps.accounts.forms import (
    AccountForm,
    AccountPermissionsForm,
    LoginForm,
    PasswordChangeForm,
    PasswordResetForm,
    RegisterForm,
    GroupForm,
)
from apps.accounts.models import Account, Group


class ListView(CoreListView):
    personal = False
    permission = "accounts.view_accounts"
    model = Account
    template_name = "accounts/list.html"


class DetailView(CoreDetailView):
    personal = True
    permission = "accounts.view_accounts"
    model = Account
    template_name = "accounts/detail.html"


class CreateView(CoreCreateView):
    personal = False
    permission = "accounts.manage_accounts"
    model = Account
    form_name = AccountForm
    template_name = "accounts/create.html"

    def post(self, request):
        form = AccountForm(request.POST)
        if form.is_valid():
            account = form.save()
            messages.success(request, _("The account has been successfully created."))
            return HttpResponseRedirect(reverse("accounts:activate", args=[account.pk]) + f"?next={self.next}")
        return render(request=request, template_name=self.template_name, context={"form": form})


class EditView(CoreEditView):
    personal = True
    permission = "accounts.manage_accounts"
    model = Account
    form_name = AccountForm
    template_name = "accounts/edit.html"


class DeleteView(CoreDeleteView):
    personal = True
    permission = "accounts.manage_accounts"
    model = Account
    template_name = "accounts/delete.html"


class PasswordChangeView(PermissionMixin, ModelMixin, RedirectMixin, View):
    personal = True
    permission = "accounts.manage_accounts"
    model = Account

    def get(self, request):
        form = PasswordChangeForm()
        return render(request=request, template_name="accounts/password/change.html", context={"form": form})

    def post(self, request):
        form = PasswordChangeForm(request.POST)
        if form.is_valid():
            form.save(self.account)
            messages.add_message(request, messages.SUCCESS, _("You have successfully changed the password."))
            return HttpResponseRedirect(self.next)
        return render(request=request, template_name="accounts/password/change.html", context={"form": form})


class LoginView(RedirectMixin, View):
    def dispatch(self, request):
        if request.user.is_authenticated:
            super().dispatch(request)
            messages.warning(request, _("You are already logged in!"))
            return HttpResponseRedirect(self.next)
        return super().dispatch(request)

    def get(self, request):
        form = LoginForm()
        return render(request=request, template_name="accounts/login.html", context={"form": form})

    def post(self, request):
        form = LoginForm(request.POST)
        if form.is_valid():
            form.login(request)
            messages.success(
                request,
                _("Welcome back, {first_name}! You have successfully logged in.").format(
                    first_name=request.user.first_name
                ),
            )
            return HttpResponseRedirect(self.next)
        return render(request=request, template_name="accounts/login.html", context={"form": form})


class LogoutView(View):
    def get(self, request):
        if request.user.is_authenticated:
            logout(request)
            messages.success(request, _("You have successfully logged out."))
        else:
            messages.warning(request, _("You are already logged out!"))
        return HttpResponseRedirect(reverse("home"))


class RegisterView(RedirectMixin, View):
    def dispatch(self, request):
        if request.user.is_authenticated:
            super().dispatch(request)
            messages.warning(request, _("You cannot register an account while being logged in!"))
            return HttpResponseRedirect(self.next)
        return super().dispatch(request)

    def get(self, request):
        form = RegisterForm()
        return render(request=request, template_name="accounts/register.html", context={"form": form})

    def post(self, request):
        form = RegisterForm(request.POST, request.FILES)
        if form.is_valid():
            form.save()
            messages.success(
                request,
                _("Welcome to {website_name}, {first_name}! You have successfully registered.").format(
                    website_name=settings.WEBSITE_NAME, first_name=form.cleaned_data["first_name"]
                ),
            )
            return HttpResponseRedirect(reverse("accounts:login"))
        return render(request=request, template_name="accounts/register.html", context={"form": form})


class PasswordResetView(View):
    def dispatch(self, request):
        if request.user.is_authenticated:
            messages.warning(request, _("You have been redirected to change your password because you are logged in!"))
            return HttpResponseRedirect(reverse("accounts:password_change", args={request.user.pk}))
        return super().dispatch(request)

    def get(self, request):
        form = PasswordResetForm()
        return render(request=request, template_name="accounts/password/reset.html", context={"form": form})

    def post(self, request):
        form = PasswordResetForm(request.POST)
        if form.is_valid():
            account = form.save()
            url = request.build_absolute_uri("/accounts/password/reset/")
            url += urlsafe_base64_encode(force_bytes(account.pk)) + "/"
            url += default_token_generator.make_token(account) + "/"

            html = render_to_string(
                "email.html",
                {
                    "url": url,
                    "header": "Reset your password",
                    "message": "Use the link below to reset your password. It will expire after 24 hours.",
                    "button": "Reset Password",
                },
            )
            text = strip_tags(html).replace(str(_("Reset Password")), url)
            subject = f"Reset your password | {settings.WEBSITE_NAME}"

            if account.send_email(subject=subject, message=text, html_message=html):
                messages.success(request, _("You have successfully requested a password reset."))
                return HttpResponseRedirect(reverse("accounts:login"))
            else:
                messages.error(request, _("The password reset email could not be sent!"))
        return render(request=request, template_name="accounts/password/reset.html", context={"form": form})


class PasswordResetConfirmView(RedirectMixin, View):
    def dispatch(self, request, uidb64, token):
        if request.user.is_authenticated:
            messages.warning(request, _("You have been redirected to change your password because you are logged in!"))
            return HttpResponseRedirect(reverse("accounts:password_change", args={request.user.pk}))
        try:
            self.account = Account.objects.get(pk=force_str(urlsafe_base64_decode(uidb64)))
            if default_token_generator.check_token(self.account, token):
                return super().dispatch(request)
            raise Account.DoesNotExist
        except (TypeError, ValueError, OverflowError, Account.DoesNotExist):
            messages.error(request, _("The password reset request is not valid."))
            return HttpResponseRedirect(reverse("accounts:password_reset"))

    def get(self, request):
        form = PasswordChangeForm()
        return render(request=request, template_name="accounts/password/reset.html", context={"form": form})

    def post(self, request):
        form = PasswordChangeForm(request.POST)
        if form.is_valid():
            form.save(account=self.account)
            messages.success(request, _("You have successfully reset your password."))
            return HttpResponseRedirect(reverse("accounts:login"))
        return render(request=request, template_name="accounts/password/reset.html", context={"form": form})


class PermissionsChangeView(PermissionMixin, ModelMixin, RedirectMixin, View):
    personal = False
    permission = "superuser"
    model = Account

    def get(self, request):
        form = AccountPermissionsForm(instance=self.account)
        return render(request=request, template_name="accounts/permissions/change.html", context={"form": form})

    def post(self, request):
        form = AccountPermissionsForm(request.POST, instance=self.account)
        if form.is_valid():
            form.save(self.account)
            messages.success(request, _("You have successfully changed the account permissions."))
            return HttpResponseRedirect(self.next)
        return render(request=request, template_name="accounts/permissions/change.html", context={"form": form})


class ActivateView(PermissionMixin, ModelMixin, RedirectMixin, View):
    personal = False
    permission = "accounts.manage_accounts"
    model = Account

    def get(self, request):
        if self.account.is_active:
            messages.warning(request, _("The account has been already activated!"))
            return HttpResponseRedirect(reverse("home"))

        url = request.build_absolute_uri("/accounts/activate/")

libreorganize/apps/accounts/templates/accounts/groups/create.html
{% extends "core/form.html" %}
{% load i18n %}

{% block title %}{% trans "Create Group" %}{% endblock title %}

{% block form_title %}
<h1>{% trans "Create Group" %}</h1>
{% endblock form_title %}

libreorganize/apps/accounts/templates/accounts/groups/delete.html
{% extends "core/delete.html" %}
{% load i18n %}

{% block title %}{% trans "Delete Group" %}{% endblock title %}

{% block form_title %}
<h1>{% trans "Delete Group" %}</h1>
{% endblock form_title %}

{% block form_message %}
{% trans "Are you sure you want to delete the group?" %}
<br>
{% trans "This action is irreversible." %}
{% endblock form_message %}

libreorganize/apps/accounts/templates/accounts/groups/detail.html
{% extends "base.html" %}
{% load formatting %}
{% load i18n %}

{% block title %}{{ group.name }}{% endblock title %}

{% block content %}
<div class="container">
    <div class="row card-row">
        <div class="col-12 mx-auto my-auto">
            <div class="card">
                <div class="card-header text-center">
                    <h1>{{ group.name }}</h1>
                </div>
                <div class="card-body">
                    <div class="container">
                        <div class="row">
                            <div class="col-md-4 col-lg-3 px-0 pr-md-2 pb-3">
                                {% if perms.accounts.view_groups %}
                                {% if not request.GET.personal %}
                                <a class="btn btn-dark btn-detail" href="{% url 'accounts:groups_list' %}">
                                    <i class="fas fa-arrow-left fa-fw mr-1"></i>
                                    {% trans "Back to Groups" %}
                                </a>
                                {% endif %}
                                {% endif %}
                                {% if perms.accounts.manage_groups %}
                                <a class="btn btn-warning btn-detail"
                                    href="{% url 'accounts:groups_edit' pk=group.pk %}?next={{ request.get_full_path }}">
                                    <i class="fas fa-pen fa-fw mr-1"></i>
                                    {% trans "Edit Group" %}
                                </a>
                                <a class="btn btn-danger btn-detail"
                                    href="{% url 'accounts:groups_delete' pk=group.pk %}?next=/accounts/groups/&cancel={{ request.get_full_path }}">
                                    <i class="fas fa-trash fa-fw mr-1"></i>
                                    {% trans "Delete Group" %}
                                </a>
                                {% endif %}
                            </div>
                            <div class="col-md-8 col-lg-9 px-0 pl-md-2">
                                <div class="table-mobile">
                                    <table class="table table-striped table-detail" id="mobileTable">
                                        <tbody>
                                            <tr>
                                                <th scope="row">{% trans "Group ID" %}</th>
                                                <td>{{ group.pk }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Name" %}</th>
                                                <td>{{ group.name }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Members" %}</th>
                                                <td>
                                                    {% for member in group.members.all %}
                                                    {% if perms.accounts.view_accounts %}
                                                    <a href="{% url 'accounts:detail' pk=member.pk %}">{{ member.full_name }}</a><br>
                                                    {% else %}
                                                    {{ member.full_name }}<br>
                                                    {% endif %}
                                                    {% endfor %}
                                                </td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Created on" %}</th>
                                                <td>{{ group.created_on }}</td>
                                            </tr>
                                            <tr>
                                                <th scope="row">{% trans "Updated on" %}</th>
                                                <td>{{ group.updated_on }}</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

libreorganize/apps/accounts/templates/accounts/groups/edit.html
{% extends "core/form.html" %}
{% load i18n %}

{% block title %}{% trans "Edit Group" %}{% endblock title %}

{% block form_title %}
<h1>{% trans "Edit Group" %}</h1>
{% endblock form_title %}

libreorganize/apps/accounts/templates/accounts/groups/list.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans "Groups" %}{% endblock title %}

{% block content %}
<div class="container">
    <div class="row card-row">
        <div class="col-12 mx-auto my-auto">
            <div class="card">
                <div class="card-header text-center">
                    <h1>{% trans "Groups" %}</h1>
                </div>
                <div class="card-body">
                    <table id="jsTable" class="table table-striped nowrap" style="width: 100%;">
                        <thead>
                            <tr>
                                <th scope="col">{% trans "Group ID" %}</th>
                                <th scope="col">{% trans "Name" %}</th>
                                <th scope="col">{% trans "No. Members" %}</th>
                                <th scope="col">{% trans "Created on" %}</th>
                                <th scope="col">
                                    {% if perms.accounts.manage_groups %}
                                    <a class="btn btn-sm btn-success"
                                        href="{% url 'accounts:groups_create' %}?next={{ request.get_full_path }}" data-toggle="tooltip"
                                        title="{% trans 'Create Group' %}">
                                        <i class="fas fa-plus fa-fw"></i>
                                    </a>
                                    {% endif %}
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for group in group_list %}
                            <tr>
                                <td>{{ group.pk }}</td>
                                <td>{{ group.name }}</td>
                                <td>{{ group.members.count }}</td>
                                <td>{{ group.created_on }}</td>
                                <td>
                                    <a class="btn btn-sm btn-info" href="{% url 'accounts:groups_detail' pk=group.pk %}"
                                        data-toggle="tooltip" title="{% trans 'View Group' %}">
                                        <i class="fas fa-eye fa-fw"></i>
                                    </a>
                                    {% if perms.accounts.manage_groups %}
                                    <a class="btn btn-sm btn-warning"
                                        href="{% url 'accounts:groups_edit' pk=group.pk %}?next={{ request.get_full_path }}"
                                        data-toggle="tooltip" title="{% trans 'Edit Group' %}">
                                        <i class="fas fa-pen fa-fw"></i>
                                    </a>
                                    <a class="btn btn-sm btn-danger"
                                        href="{% url 'accounts:groups_delete' pk=group.pk %}?next={{ request.get_full_path }}"
                                        data-toggle="tooltip" title="{% trans 'Delete Group' %}">
                                        <i class="fas fa-trash fa-fw"></i>
                                    </a>
                                    {% endif %}
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock content %}